/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-06 19:17:05 UTC)
 * on 2013-05-07 at 00:06:14 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for CommunityMembershipStatus.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityMembershipStatus extends com.google.api.client.json.GenericJson {

  /**
   * Whether the user can create a poll in this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean canCreatePoll;

  /**
   * Whether the user can create a topic in this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean canCreateTopic;

  /**
   * Whether the user can perform a shout operation in this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean canShout;

  /**
   * Whether the session user is a community co-owner.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isCoOwner;

  /**
   * Whether the user is following this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isFollowing;

  /**
   * Whether the session user is a community moderator.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isModerator;

  /**
   * Whether the session user is the community owner.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isOwner;

  /**
   * Whether the restore operation is available for the community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isRestoreAvailable;

  /**
   * Whether the take-back operation is available for the community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isTakebackAvailable;

  /**
   * Kind of this item. Always orkut#communityMembershipStatus.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The status of the current link between the community and the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Whether the user can create a poll in this community.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getCanCreatePoll() {
    return canCreatePoll;
  }

  /**
   * Whether the user can create a poll in this community.
   * @param canCreatePoll canCreatePoll or {@code null} for none
   */
  public CommunityMembershipStatus setCanCreatePoll(java.lang.Boolean canCreatePoll) {
    this.canCreatePoll = canCreatePoll;
    return this;
  }

  /**
   * Whether the user can create a topic in this community.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getCanCreateTopic() {
    return canCreateTopic;
  }

  /**
   * Whether the user can create a topic in this community.
   * @param canCreateTopic canCreateTopic or {@code null} for none
   */
  public CommunityMembershipStatus setCanCreateTopic(java.lang.Boolean canCreateTopic) {
    this.canCreateTopic = canCreateTopic;
    return this;
  }

  /**
   * Whether the user can perform a shout operation in this community.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getCanShout() {
    return canShout;
  }

  /**
   * Whether the user can perform a shout operation in this community.
   * @param canShout canShout or {@code null} for none
   */
  public CommunityMembershipStatus setCanShout(java.lang.Boolean canShout) {
    this.canShout = canShout;
    return this;
  }

  /**
   * Whether the session user is a community co-owner.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsCoOwner() {
    return isCoOwner;
  }

  /**
   * Whether the session user is a community co-owner.
   * @param isCoOwner isCoOwner or {@code null} for none
   */
  public CommunityMembershipStatus setIsCoOwner(java.lang.Boolean isCoOwner) {
    this.isCoOwner = isCoOwner;
    return this;
  }

  /**
   * Whether the user is following this community.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsFollowing() {
    return isFollowing;
  }

  /**
   * Whether the user is following this community.
   * @param isFollowing isFollowing or {@code null} for none
   */
  public CommunityMembershipStatus setIsFollowing(java.lang.Boolean isFollowing) {
    this.isFollowing = isFollowing;
    return this;
  }

  /**
   * Whether the session user is a community moderator.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsModerator() {
    return isModerator;
  }

  /**
   * Whether the session user is a community moderator.
   * @param isModerator isModerator or {@code null} for none
   */
  public CommunityMembershipStatus setIsModerator(java.lang.Boolean isModerator) {
    this.isModerator = isModerator;
    return this;
  }

  /**
   * Whether the session user is the community owner.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsOwner() {
    return isOwner;
  }

  /**
   * Whether the session user is the community owner.
   * @param isOwner isOwner or {@code null} for none
   */
  public CommunityMembershipStatus setIsOwner(java.lang.Boolean isOwner) {
    this.isOwner = isOwner;
    return this;
  }

  /**
   * Whether the restore operation is available for the community.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsRestoreAvailable() {
    return isRestoreAvailable;
  }

  /**
   * Whether the restore operation is available for the community.
   * @param isRestoreAvailable isRestoreAvailable or {@code null} for none
   */
  public CommunityMembershipStatus setIsRestoreAvailable(java.lang.Boolean isRestoreAvailable) {
    this.isRestoreAvailable = isRestoreAvailable;
    return this;
  }

  /**
   * Whether the take-back operation is available for the community.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsTakebackAvailable() {
    return isTakebackAvailable;
  }

  /**
   * Whether the take-back operation is available for the community.
   * @param isTakebackAvailable isTakebackAvailable or {@code null} for none
   */
  public CommunityMembershipStatus setIsTakebackAvailable(java.lang.Boolean isTakebackAvailable) {
    this.isTakebackAvailable = isTakebackAvailable;
    return this;
  }

  /**
   * Kind of this item. Always orkut#communityMembershipStatus.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of this item. Always orkut#communityMembershipStatus.
   * @param kind kind or {@code null} for none
   */
  public CommunityMembershipStatus setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The status of the current link between the community and the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * The status of the current link between the community and the user.
   * @param status status or {@code null} for none
   */
  public CommunityMembershipStatus setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  @Override
  public CommunityMembershipStatus set(String fieldName, Object value) {
    return (CommunityMembershipStatus) super.set(fieldName, value);
  }

  @Override
  public CommunityMembershipStatus clone() {
    return (CommunityMembershipStatus) super.clone();
  }

}
