/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-06 19:17:05 UTC)
 * on 2013-05-07 at 00:06:14 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for OrkutActivitypersonResource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class OrkutActivitypersonResource extends com.google.api.client.json.GenericJson {

  /**
   * The person's date of birth, represented as YYYY-MM-DD.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String birthday;

  /**
   * The person's gender. Values include "male", "female", and "other".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String gender;

  /**
   * The person's opensocial ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Image image;

  /**
   * An object that encapsulates the individual components of a person's name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Name name;

  /**
   * The person's profile url. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String url;

  /**
   * The person's date of birth, represented as YYYY-MM-DD.
   * @return value or {@code null} for none
   */
  public java.lang.String getBirthday() {
    return birthday;
  }

  /**
   * The person's date of birth, represented as YYYY-MM-DD.
   * @param birthday birthday or {@code null} for none
   */
  public OrkutActivitypersonResource setBirthday(java.lang.String birthday) {
    this.birthday = birthday;
    return this;
  }

  /**
   * The person's gender. Values include "male", "female", and "other".
   * @return value or {@code null} for none
   */
  public java.lang.String getGender() {
    return gender;
  }

  /**
   * The person's gender. Values include "male", "female", and "other".
   * @param gender gender or {@code null} for none
   */
  public OrkutActivitypersonResource setGender(java.lang.String gender) {
    this.gender = gender;
    return this;
  }

  /**
   * The person's opensocial ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The person's opensocial ID.
   * @param id id or {@code null} for none
   */
  public OrkutActivitypersonResource setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * @return value or {@code null} for none
   */
  public Image getImage() {
    return image;
  }

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * @param image image or {@code null} for none
   */
  public OrkutActivitypersonResource setImage(Image image) {
    this.image = image;
    return this;
  }

  /**
   * An object that encapsulates the individual components of a person's name.
   * @return value or {@code null} for none
   */
  public Name getName() {
    return name;
  }

  /**
   * An object that encapsulates the individual components of a person's name.
   * @param name name or {@code null} for none
   */
  public OrkutActivitypersonResource setName(Name name) {
    this.name = name;
    return this;
  }

  /**
   * The person's profile url. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * @return value or {@code null} for none
   */
  public java.lang.String getUrl() {
    return url;
  }

  /**
   * The person's profile url. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * @param url url or {@code null} for none
   */
  public OrkutActivitypersonResource setUrl(java.lang.String url) {
    this.url = url;
    return this;
  }

  @Override
  public OrkutActivitypersonResource set(String fieldName, Object value) {
    return (OrkutActivitypersonResource) super.set(fieldName, value);
  }

  @Override
  public OrkutActivitypersonResource clone() {
    return (OrkutActivitypersonResource) super.clone();
  }

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   */
  public static final class Image extends com.google.api.client.json.GenericJson {

    /**
     * The URL of the person's profile photo.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String url;

    /**
     * The URL of the person's profile photo.
     * @return value or {@code null} for none
     */
    public java.lang.String getUrl() {
      return url;
    }

    /**
     * The URL of the person's profile photo.
     * @param url url or {@code null} for none
     */
    public Image setUrl(java.lang.String url) {
      this.url = url;
      return this;
    }

    @Override
    public Image set(String fieldName, Object value) {
      return (Image) super.set(fieldName, value);
    }

    @Override
    public Image clone() {
      return (Image) super.clone();
    }

  }

  /**
   * An object that encapsulates the individual components of a person's name.
   */
  public static final class Name extends com.google.api.client.json.GenericJson {

    /**
     * The family name (last name) of this person.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String familyName;

    /**
     * The given name (first name) of this person.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String givenName;

    /**
     * The family name (last name) of this person.
     * @return value or {@code null} for none
     */
    public java.lang.String getFamilyName() {
      return familyName;
    }

    /**
     * The family name (last name) of this person.
     * @param familyName familyName or {@code null} for none
     */
    public Name setFamilyName(java.lang.String familyName) {
      this.familyName = familyName;
      return this;
    }

    /**
     * The given name (first name) of this person.
     * @return value or {@code null} for none
     */
    public java.lang.String getGivenName() {
      return givenName;
    }

    /**
     * The given name (first name) of this person.
     * @param givenName givenName or {@code null} for none
     */
    public Name setGivenName(java.lang.String givenName) {
      this.givenName = givenName;
      return this;
    }

    @Override
    public Name set(String fieldName, Object value) {
      return (Name) super.set(fieldName, value);
    }

    @Override
    public Name clone() {
      return (Name) super.clone();
    }

  }

}
